VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MedCutNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Red1 As Byte, Red2 As Byte
Public Green1 As Byte, Green2 As Byte
Public Blue1 As Byte, Blue2 As Byte
Public SplitDir As Byte '0=Red,1=Green,2=Blue
Public Child1 As MedCutNode, Child2 As MedCutNode
Public Pixel1 As Long, Pixel2 As Long
Public PalEntry As Byte

Public Sub SetBounds(ByVal Bound1 As Long, ByVal Bound2 As Long)
Pixel1 = Bound1: Pixel2 = Bound2
Red1 = 255: Red2 = 0
Green1 = 255: Green2 = 0
Blue1 = 255: Blue2 = 0
Dim i As Integer
For i = Bound1 To Bound2
    With Pixels(i)
        If .Red < Red1 Then Red1 = .Red
        If .Red > Red2 Then Red2 = .Red
        If .Green < Green1 Then Green1 = .Green
        If .Green > Green2 Then Green2 = .Green
        If .Blue < Blue1 Then Blue1 = .Blue
        If .Blue > Blue2 Then Blue2 = .Blue
    End With
Next
End Sub

Public Sub Split()
If (Child1 Is Nothing) And (Child2 Is Nothing) Then
    If (Red2 - Red1) > (Green2 - Green1) Then
    '?R?G?
        If (Red2 - Red1) > (Blue2 - Blue1) Then
            SplitDir = 0
            QSortRed Pixel1, Pixel2
        Else
            SplitDir = 2
            QSortBlue Pixel1, Pixel2
        End If
    Else
    '?G?R?
        If (Green2 - Green1) > (Blue2 - Blue1) Then
            SplitDir = 1
            QSortGreen Pixel1, Pixel2
        Else
            SplitDir = 2
            QSortBlue Pixel1, Pixel2
        End If
    End If
    Set Child1 = New MedCutNode
    Child1.SetBounds Pixel1, (Pixel1 + Pixel2) \ 2
    Set Child2 = New MedCutNode
    Child2.SetBounds (Pixel1 + Pixel2) \ 2 + 1, Pixel2
Else
    Child1.Split
    Child2.Split
End If
End Sub

Public Sub FillPalette(Palette() As OLE_COLOR, Index As Integer)
Dim i As Integer, r As Long, g As Long, b As Long
If (Child1 Is Nothing) And (Child2 Is Nothing) Then
    For i = Pixel1 To Pixel2
        r = r + Pixels(i).Red
        g = g + Pixels(i).Green
        b = b + Pixels(i).Blue
    Next
    r = r / (Pixel2 - Pixel1 + 1)
    g = g / (Pixel2 - Pixel1 + 1)
    b = b / (Pixel2 - Pixel1 + 1)
    Palette(Index) = r + 256& * g + 65536 * b
    PalEntry = Index
    Index = Index + 1
Else
    Child1.FillPalette Palette, Index
    Child2.FillPalette Palette, Index
End If
End Sub

Public Function GetPaletteIndex(ByVal r As Byte, ByVal g As Byte, ByVal b As Byte) As Byte
If (Child1 Is Nothing) And (Child2 Is Nothing) Then
    GetPaletteIndex = PalEntry
Else
    Dim Child As MedCutNode
    Select Case SplitDir
    Case 0:
        If Child1.Red2 < r Then Set Child = Child2 Else Set Child = Child1
    Case 1:
        If Child1.Green2 < g Then Set Child = Child2 Else Set Child = Child1
    Case 2:
        If Child1.Blue2 < b Then Set Child = Child2 Else Set Child = Child1
    End Select
    GetPaletteIndex = Child.GetPaletteIndex(r, g, b)   ' recursion
End If
End Function

