Attribute VB_Name = "modQSortRGB"
Option Explicit

Public Type RGB
    Red As Integer
    Green As Integer
    Blue As Integer
End Type
Public Pixels() As RGB

Public Sub QSortRed(ByVal intLowBound As Long, ByVal intHighBound As Long)
    Dim intX As Long
    Dim intY As Long
    Dim varMidBound As Integer
    Dim varTmp As RGB

    ' If there is data to sort
    If intHighBound > intLowBound Then
        ' Calculate the value of the middle array element
        varMidBound = Pixels((intLowBound + intHighBound) \ 2).Red
        intX = intLowBound
        intY = intHighBound

        ' Split the array into halves
        Do While intX <= intY
            If Pixels(intX).Red >= varMidBound And _
               Pixels(intY).Red <= varMidBound _
            Then
                varTmp = Pixels(intX)
                Pixels(intX) = Pixels(intY)
                Pixels(intY) = varTmp
                intX = intX + 1
                intY = intY - 1
            Else
                If Pixels(intX).Red < varMidBound Then
                    intX = intX + 1
                End If
                If Pixels(intY).Red > varMidBound Then
                    intY = intY - 1
                End If
            End If
        Loop

        ' Sort the lower half of the array
        QSortRed intLowBound, intY

        ' Sort the upper half of the array
        QSortRed intX, intHighBound
    End If
End Sub

Public Sub QSortGreen(ByVal intLowBound As Long, ByVal intHighBound As Long)
    Dim intX As Long
    Dim intY As Long
    Dim varMidBound As Integer
    Dim varTmp As RGB

    ' If there is data to sort
    If intHighBound > intLowBound Then
        ' Calculate the value of the middle array element
        varMidBound = Pixels((intLowBound + intHighBound) \ 2).Green
        intX = intLowBound
        intY = intHighBound

        ' Split the array into halves
        Do While intX <= intY
            If Pixels(intX).Green >= varMidBound And _
               Pixels(intY).Green <= varMidBound _
            Then
                varTmp = Pixels(intX)
                Pixels(intX) = Pixels(intY)
                Pixels(intY) = varTmp
                intX = intX + 1
                intY = intY - 1
            Else
                If Pixels(intX).Green < varMidBound Then
                    intX = intX + 1
                End If
                If Pixels(intY).Green > varMidBound Then
                    intY = intY - 1
                End If
            End If
        Loop

        ' Sort the lower half of the array
        QSortGreen intLowBound, intY

        ' Sort the upper half of the array
        QSortGreen intX, intHighBound
    End If
End Sub

Public Sub QSortBlue(ByVal intLowBound As Long, ByVal intHighBound As Long)
    Dim intX As Long
    Dim intY As Long
    Dim varMidBound As Integer
    Dim varTmp As RGB

    ' If there is data to sort
    If intHighBound > intLowBound Then
        ' Calculate the value of the middle array element
        varMidBound = Pixels((intLowBound + intHighBound) \ 2).Blue
        intX = intLowBound
        intY = intHighBound

        ' Split the array into halves
        Do While intX <= intY
            If Pixels(intX).Blue >= varMidBound And _
               Pixels(intY).Blue <= varMidBound _
            Then
                varTmp = Pixels(intX)
                Pixels(intX) = Pixels(intY)
                Pixels(intY) = varTmp
                intX = intX + 1
                intY = intY - 1
            Else
                If Pixels(intX).Blue < varMidBound Then
                    intX = intX + 1
                End If
                If Pixels(intY).Blue > varMidBound Then
                    intY = intY - 1
                End If
            End If
        Loop

        ' Sort the lower half of the array
        QSortBlue intLowBound, intY

        ' Sort the upper half of the array
        QSortBlue intX, intHighBound
    End If
End Sub
